/*
	This software is free software; you can redistribute it and/or modify
	it under the terms of the GNU  General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.
																																																																																																							 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU  General Public License for more details.
																																																																																																							 
	You should have received a copy of the GNU  General Public
	License along with this software; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
	02111-1307, USA.
*/
#ifndef  __FFT_H__
#define  __FFT_H__

typedef struct {
	float re, im;
	} complex;

void complex_add(complex *result, complex *x, complex *y);
void complex_sub(complex *result, complex *x, complex *y);
void complex_mul(complex *result, complex *x, complex *y);
void complex_pow(complex *result, complex *base, int exponent);
float complex_abs(complex *v);
int bit_wise(int a, int n);
void fft(complex *vector, int ln);
void ifft(complex *vector, int ln);
int log2i(int n);

#endif   /* __FFT_H__ */
